(* Copyright (C) 1995, Digital Equipment Corporation                         *)
(* Digital Internal Use Only                                                 *)
(* All rights reserved.                                                      *)
(*                                                                           *)
(* Last modified on Tue Feb 21 13:49:38 PST 1995 by najork                   *)
(*       Created on Tue Jan 17 16:04:49 PST 1995 by najork                   *)

(*
 * The following procedures are not yet implemented:
 *   List
 *   Match 
 *   Lookup
 *)

UNSAFE INTERFACE WinScrnFont;

IMPORT PaintPrivate, ScrnFont, TrestleComm, WinDef, WinScreenType;

PROCEDURE NewOracle (st: WinScreenType.T; depthOne: BOOLEAN): ScrnFont.Oracle
    RAISES {TrestleComm.Failure};
(* Create a ScrnFont.Oracle suitable for use with a screen type "st".
   If "depthOne" is TRUE, then the oracle will be suitable for a 1-bit 
   font for painting on screens of type "st".  See the description of 
   "bits" in ScreenType.i3

   It is not clear to me if the "depthOne" stuff is just an X artifact, or
   something independent of the window system. From glancing over the code,
   it seems that Oracles which are generated with "depthOne: being false
   simply dispatch all messages to another Oracle (attached to "st.bits")
   which was created with "depthOne" being true.

   For now, I ignore the "depthOne' field. *)

PROCEDURE FromFont (font: PaintPrivate.Font): WinDef.HFONT;

END WinScrnFont.
